<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Hash routines
'*********************************************************************************

const XConvertPlainText = "Yes"

'This routine called by EnDeCrypt function. Initializes the
'sbox and the key array)
sub EnDeCryptInit(strPwd,sbox)
   dim tempSwap
   dim a
   dim b, intLength
   dim key(255)

   intLength = len(strPwd)
   for a = 0 to 255
      key(a) = asc(mid(strpwd, (a mod intLength) + 1, 1))
      sbox(a) = a
   next

   b = 0
   for a = 0 to 255
      b = (b + sbox(a) + key(a)) mod 256
      tempSwap = sbox(a)
      sbox(a) = sbox(b)
      sbox(b) = tempSwap
   next
end sub

'This routine does all the work. Call it both to ENcrypt
'and to DEcrypt your data.
function EnDeCrypt(plaintxt, psw)
   '700 - 2010.06.23 - Enhancement: shophash.asp enhanced to cover payment gateways
   session("fromshophashitself") = ""

   '700 - 2010.06.20 - Enhancement: Ensure encrytion is always at codepage 1252
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 1252

   dim pos, dotchar, plainflag
   plainflag = false

   if len(plaintxt)>20 then
      pos = instr(plaintxt, ".")
      if pos>0 then
         plaintxt = Convertfromplain(plaintxt)
         plainflag = true
      end if
   end if
   dim temp
   dim a
   dim i
   dim j
   dim k
   dim cipherby
   dim cipher

   i = 0
   j = 0
   dim sbox(255)
   EnDecryptInit psw,sbox
   on error resume next
   for a = 1 to len(plaintxt)
      i = (i + 1) mod 256
      j = (j + sbox(i)) mod 256
      temp = sbox(i)
      sbox(i) = sbox(j)
      sbox(j) = temp

      k = sbox((sbox(i) + sbox(j)) mod 256)

      cipherby = asc(mid(plaintxt, a, 1)) xor k
      cipher = cipher & chr(cipherby)
   next
   EnDeCrypt = cipher

   '700 - 2010.06.20 - Enhancement: Ensure encrytion is always at codepage 1252
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 65001
end function

function PrintHex (idata)
   dim fieldvalue, i, txt
   txt = idata
   for x = 1 to len(txt)
      Fieldvalue = Fieldvalue & right(string(2, "0") & hex(asc(mid(idata, x, 1))), 2)
   next
   Printhex = fieldvalue
end function

function PrintBrowser (idata)
   PrintBrowser = server.urlencode(idata)
end function

function GetEncryptKey
   if xencryptkey = "" then
      GetEncryptKey = GetConfig("xencryptkey")
   else
      GetEncryptKey = xencryptkey
   end if
end function

'Base 64 Encoding
'Horizyn
'April 2002
'This algorithm is used for converting binary data into ASCII format so it is able to be
'transmitted and viewed in a simple manner.
'The algorithm may then decode the data back
'into its binary form.  In this way encrypted data may be easily stored in Databases/text files/XML
'etc.

'Usage: Include the shop_base64 file into your ASP file, call the initCodecs function before
'calling any encode/decode functions, then
const BASE_64_MAP_INIT = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
' zero based arrays
dim Base64EncMap(63)
dim Base64DecMap(127)

' must be called before using anything else
public sub initCodecs()
   ' init vars
   ' setup base 64
   dim max, idx
   max = len(BASE_64_MAP_INIT)
   for idx = 0 to max - 1
      ' one based string
      Base64EncMap(idx) = mid(BASE_64_MAP_INIT, idx + 1, 1)
   next
   for idx = 0 to max - 1
      Base64DecMap(asc(Base64EncMap(idx))) = idx
   next
end sub

' encode base 64 encoded string
function base64Encode(plain)
   if len(plain) = 0 then
      base64Encode = ""
      exit function
   end if

   dim ret, ndx, by3, first, second, third
   by3 = (len(plain) \ 3) * 3
   ndx = 1
   do while ndx <= by3
      first = asc(mid(plain, ndx + 0, 1))
      second = asc(mid(plain, ndx + 1, 1))
      third = asc(mid(plain, ndx + 2, 1))
      ret = ret & Base64EncMap( (first \ 4) and 63 )
      ret = ret & Base64EncMap( ((first * 16) and 48) + ((second \ 16) and 15 ) )
      ret = ret & Base64EncMap( ((second * 4) and 60) + ((third \ 64) and 3 ) )
      ret = ret & Base64EncMap( third and 63)
      ndx = ndx + 3
   loop
   ' check for stragglers
   if by3 < len(plain) then
      first = asc(mid(plain, ndx + 0, 1))
      ret = ret & Base64EncMap( (first \ 4) and 63 )
      if (len(plain) mod 3 ) = 2 then
         second = asc(mid(plain, ndx + 1, 1))
         ret = ret & Base64EncMap( ((first * 16) and 48) + ((second \ 16) and 15 ) )
         ret = ret & Base64EncMap( ((second * 4) and 60) )
      else
         ret = ret & Base64EncMap( (first * 16) and 48)
         ret = ret & "="
      end if
      ret = ret & "="
   end if

   base64Encode = ret
end function

' decode base 64 encoded string
function base64Decode(scrambled)

   if len(scrambled) = 0 then
      base64Decode = ""
      exit function
   end if

   ' ignore padding
   dim realLen
   realLen = len(scrambled)
   do while mid(scrambled, realLen, 1) = "="
      realLen = realLen - 1
   loop
   dim ret, ndx, by4, first, second, third, fourth
   ret = ""
   by4 = (realLen \ 4) * 4
   ndx = 1
   do while ndx <= by4
      first = Base64DecMap(asc(mid(scrambled, ndx + 0, 1)))
      second = Base64DecMap(asc(mid(scrambled, ndx + 1, 1)))
      third = Base64DecMap(asc(mid(scrambled, ndx + 2, 1)))
      fourth = Base64DecMap(asc(mid(scrambled, ndx + 3, 1)))
      ret = ret & chr( ((first * 4) and 255) + ((second \ 16) and 3))
      ret = ret & chr( ((second * 16) and 255) + ((third \ 4) and 15) )
      ret = ret & chr( ((third * 64) and 255) + (fourth and 63) )
      ndx = ndx + 4
   loop
   ' check for stragglers, will be 2 or 3 characters
   if ndx < realLen then
      first = Base64DecMap(asc(mid(scrambled, ndx + 0, 1)))
      second = Base64DecMap(asc(mid(scrambled, ndx + 1, 1)))
      ret = ret & chr( ((first * 4) and 255) + ((second \ 16) and 3))
      if realLen mod 4 = 3 then
         third = Base64DecMap(asc(mid(scrambled, ndx + 2, 1)))
         ret = ret & chr( ((second * 16) and 255) + ((third \ 4) and 15) )
      end if
   end if

   base64Decode = ret
end function

'Convert to plain text
function Converttoplain(Message)
   '700 - 2010.06.23 - Enhancement: shophash.asp enhanced to cover payment gateways
   if session("fromshophashitself") <> "Yes" then
      '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
      Assigncodepagevalue 1252
   end if

   if xconvertplaintext<>"Yes" then
      Converttoplain = Message
      exit function
   end if
   dim temp, char, i, num
   Temp = ""
   for i = 1 to len(Message)
      Char = mid(Message, i, 1)
      Num = asc(Char)
      if i <> 1 then
         Temp = Temp & "." & Num
      else
         Temp = Temp & Num
      end if
   next
   Converttoplain = Temp

   '700 - 2010.06.23 - Enhancement: shophash.asp enhanced to cover payment gateways
   if session("fromshophashitself") <> "Yes" then
      '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
      Assigncodepagevalue 65001
   end if
end function

function Convertfromplain(Message)
   if xconvertplaintext<>"Yes" then
      Convertfromplain = Message
      exit function
   end if

   dim Nums
   dim i
   dim Temp
   Temp = ""

   Nums = split(Message, ".", -1, 1)
   for i = 0 to ubound(Nums)
      Temp = Temp & chr(Nums(i))
   next
   Convertfromplain = temp
end function

'700 Encrypt admin username and password
function EnDeCrypt2(plaintxt, psw, ptype)
   '700 - 2010.06.20 - Enhancement: Ensure encrytion is always at codepage 1252
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 1252

   dim pos, dotchar, plainflag
   if ptype="D" then
      plainflag=false
      If len(plaintxt)>0 then
         pos=Instr(plaintxt,".")
         If pos>0 then
            plaintxt=Convertfromplain(plaintxt)
            plainflag=true
         end if
      end if
   end if

   dim temp
   dim a
   dim i
   dim j
   dim k
   dim cipherby
   dim cipher

   i = 0
   j = 0
   dim sbox(255)
   EnDecryptInit psw,sbox

   For a = 1 To Len(plaintxt)
      i = (i + 1) Mod 256
      j = (j + sbox(i)) Mod 256
      temp = sbox(i)
      sbox(i) = sbox(j)
      sbox(j) = temp
      k = sbox((sbox(i) + sbox(j)) Mod 256)
      cipherby = Asc(Mid(plaintxt, a, 1)) Xor k
      cipher = cipher & Chr(cipherby)
   Next
   
   '700 - 2010.06.23 - Enhancement: shophash.asp enhanced to cover payment gateways
   if ptype = "E" then
      session("fromshophashitself") = "Yes"
      EnDeCrypt2 = Converttoplain(cipher)
   else
      EnDeCrypt2 = cipher
   end if
   session("fromshophashitself") = ""

   '700 - 2010.06.20 - Enhancement: Ensure encrytion is always at codepage 1252
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 65001
End function
%>